''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''
''  THIS CODE IS NOT REDISTRIBUTABLE OR APPROVED FOR USE IN/ON ANY OTHER UI 
''  ELEMENT OR PRODUCT COMPONENT.
''  Copyright (c) Microsoft Corporation.  All rights reserved.
''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''
'' Validate the version of Outlook is installed.  Returns boolean. 
''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
function CheckOutlookVersion()
	on error resume next
	Dim wshShell
	Set wshShell = CreateObject("WScript.Shell")
	
	dim value
	value = wshShell.RegRead("HKEY_CLASSES_ROOT\Outlook.Application\CurVer\")

		CheckOutlookVersion = true

	set wshShell = nothing
end function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''
'' Opens a connection to the Outlook object model.  Returns true if sucessful
''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
function ConnectToOutlook()
	on error resume next
	Set outlookApplication = GetObject(, "Outlook.Application")
	
	if outlookApplication is Nothing then
		outlookFailed = true
		ConnectToOutlook = false
	else
	    dim versionString
	    versionString = outlookApplication.Version

			outlookFailed = false
			ConnectToOutlook = true
		
	end if
end function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''
'' Shuts down the connection to the Outlook object model.
''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
sub DisconnectFromOutlook()
    if not outlookApplication is nothing then
	    Set outlookApplication = nothing
	end if
end sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''
'' Return a VB/COM date time object for right now
''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
function GetCurrentDateTime()
	GetCurrentDateTime = Now()
end function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''
'' Return a date value for a given offset
''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function GetDateValue(name)
    Dim workingDate
    workingDate = Date
    
    Select Case name
        Case "today"
            ' do nothing
            
        Case "tomorrow"
            workingDate = workingDate + 1
        
        Case "thisweek"
            difference = Weekday(workingDate)
            If difference = 1 Or difference > 5 Then
                difference = 0
            Else
                difference = difference + (difference - 3) * -2
            End If
            workingDate = workingDate + difference
        
        Case "nextweek"
            difference = Weekday(workingDate)
            If difference = 1 Then
                difference = -2
            Else
                difference = difference + (difference - 3) * -2
            End If
            workingDate = workingDate + difference + 7
    End Select
    GetDateValue = workingDate
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''
'' Bucketing logic for date based arrangements
''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function BucketNumberFromDate(datevalue)
	If (datevalue = #1/1/4501#) then
		BucketNumberFromDate = 7	
	ElseIf (datevalue < Date) Then
        BucketNumberFromDate = 6
    ElseIf DateDiff("d", Date, datevalue) = 0 Then
        BucketNumberFromDate = 6    ' today
    ElseIf DateDiff("d", Date, datevalue) = 1 Then
        BucketNumberFromDate = 5    ' tomorrow
    ElseIf DateDiff("ww", Date, datevalue) = 0 Then
        BucketNumberFromDate = 4    ' this week
    ElseIf DateDiff("ww", Date, datevalue) = 1 Then
        BucketNumberFromDate = 3    ' next week
    ElseIf DateDiff("m", Date, datevalue) = 0 Then
        BucketNumberFromDate = 2    ' this month
    ElseIf DateDiff("m", Date, datevalue) = 1 Then
        BucketNumberFromDate = 1    ' next month
    Else
        BucketNumberFromDate = 0    ' later
    End If
End Function

Function GetWeekDayNames()
	dim values
	for i = 1 to 7
		values = values & "," & WeekDayName(i, true)
	next
	
	GetWeekDayNames = mid(values, 2)
End Function
